<template>
  <div id="users">
    <CoscineHeadline :headline="$t('page.members.title')" />

    <div class="UserManagement">
      <!-- Search Row  -->
      <UserSearchRow
        :member-role="memberRole"
        :project="project"
        :roles="roles"
        :project-members="projectMembers"
        :is-owner="isOwner"
        @addUser="addUser"
        @prepareInvitation="prepareInvitation"
        @setFilter="setFilter"
      />
      <br />
      <b-row>
        <b-col>
          <b-tabs content-class="mt-2">
            <!-- Project Members  -->
            <b-tab :title="$t('page.members.membersTabTitle')">
              <MembersTable
                id="userTable"
                :headers="memberHeaders"
                :items="projectRoles"
                :filter="filter"
                :busy="isBusy"
                :roles="roles"
                :empty-text="$t('page.members.emptyTableText')"
                :empty-filtered-text="$t('page.members.emptyFilterText')"
                :delete-text="$t('buttons.delete')"
                :remove-text="$t('buttons.remove')"
                :owner-count="ownerCount"
                :owner-role="ownerRole"
                :interactive="isOwner"
                @tableFilteredRows="onFilteredRows"
                @setRole="setRole"
                @selectedItem="prepareDeletion"
              />
            </b-tab>

            <!-- Invited Users  -->
            <b-tab
              v-if="isOwner"
              :title="$t('page.members.externalUsersTabTitle')"
            >
              <MembersTable
                id="invitationTable"
                :headers="invitationHeaders"
                :items="invitations"
                :filter="filter"
                :busy="isBusy"
                :roles="roles"
                :empty-text="$t('page.members.emptyTableText')"
                :empty-filtered-text="$t('page.members.emptyFilterText')"
                :delete-text="$t('buttons.delete')"
                :remove-text="$t('buttons.remove')"
                :owner-count="ownerCount"
                :owner-role="ownerRole"
                :sort-by="[{ key: 'email', order: 'desc' }]"
                @revokeInvitation="revokeInvitation"
                @resendInvitation="resendInvitation"
              />
            </b-tab>
          </b-tabs>
        </b-col>
      </b-row>

      <!-- Modal Revoke Invited Email  -->
      <DeleteModal
        description-key="page.members.removeSelectedInvitation"
        title-key="page.members.deleteInvitationTitle"
        :visible="isDeleteInvitedUserModalVisible"
        :selected-user="selectedInvitation.email"
        :selected-project="projectName"
        @delete="confirmRevokeInvitation"
        @close="closeInvitedUserModal"
      />

      <!--- Modal Delete Current Members --->
      <DeleteModal
        :visible="isDeleteUserModalVisible"
        :selected-user="
          candidateForDeletion.user ? candidateForDeletion.user.displayName : ''
        "
        :selected-project="projectName"
        @delete="deleteUser"
        @close="closeUserModal"
      />

      <!-- Modal Invitation Pending  -->
      <InvitationPendingModal
        :candidate-for-invitation="candidateForInvitation"
      />

      <!-- Modal User Import  -->
      <ImportUserModal
        :member-headers="memberHeaders"
        :member-role="memberRole"
        :project="project"
        :project-roles="projectRoles"
        :roles="roles"
        @addUser="addUser"
      />

      <!-- Modal User Invite  -->
      <InviteUserModal
        :candidate-for-invitation="candidateForInvitation"
        :project-name="projectName"
        :roles="roles"
        @storeNewInvitation="storeNewInvitation"
      />
    </div>
  </div>
</template>

<script lang="ts">
import MembersTable from "./components/MembersTable.vue";
import UserSearchRow from "./components/UserSearchRow.vue";
import DeleteModal from "./components/modals/DeleteModal.vue";
import ImportUserModal from "./components/modals/ImportUserModal.vue";
import InvitationPendingModal from "./components/modals/InvitationPendingModal.vue";
import InviteUserModal from "./components/modals/InviteUserModal.vue";

// import the store for current module
import useProjectStore from "../store";
import useUserStore from "@/modules/user/store";
import useNotificationStore from "@/store/notification";

import { type TableField, useModal } from "bootstrap-vue-next";

import type {
  ProjectDto,
  ProjectInvitationDto,
  ProjectInvitationForProjectManipulationDto,
  ProjectRoleDto,
  ProjectRoleForProjectCreationDto,
  ProjectRoleForProjectManipulationDto,
  RoleDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import type { ExtendedProjectInvitationDto } from "../types";

export default defineComponent({
  components: {
    MembersTable,
    UserSearchRow,
    DeleteModal,
    ImportUserModal,
    InvitationPendingModal,
    InviteUserModal,
  },
  setup() {
    const projectStore = useProjectStore();
    const userStore = useUserStore();
    const notificationStore = useNotificationStore();

    const invitationPendingModal = useModal("invitationPendingModal");
    const inviteUserModal = useModal("inviteUserModal");

    return {
      projectStore,
      userStore,
      notificationStore,
      invitationPendingModal,
      inviteUserModal,
    };
  },

  data() {
    return {
      // For controlling delete modals
      isDeleteInvitedUserModalVisible: false,
      isDeleteUserModalVisible: false,
      // For external users
      selectedInvitation: {} as ProjectInvitationDto,
      isRevokeInvitationModalVisible: false,
      // Other
      isBusy: false,
      filteredRows: 0,
      filter: "",
      candidateForDeletion: {} as ProjectRoleDto,
      candidateForInvitation: {} as ExtendedProjectInvitationDto,
      roleStrings: {
        member: "Member",
        owner: "Owner",
      },
    };
  },

  computed: {
    invitations(): ProjectInvitationDto[] {
      return this.projectStore.currentInvitations ?? [];
    },
    memberRole(): RoleDto | null | undefined {
      if (this.roles) {
        return this.roles.find(
          (role) => role.displayName === this.roleStrings.member,
        );
      }
      return null;
    },
    ownerRole(): RoleDto | null | undefined {
      if (this.roles) {
        return this.roles.find(
          (role) => role.displayName === this.roleStrings.owner,
        );
      }
      return null;
    },
    ownerCount(): number {
      if (this.projectRoles && this.ownerRole) {
        return this.projectRoles.filter(
          (projectRole) => projectRole.role?.id === this.ownerRole?.id,
        ).length;
      }
      return 0;
    },
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    projectName(): string | null | undefined {
      return this.project?.displayName;
    },
    projectRoles(): ProjectRoleDto[] {
      return this.projectStore.currentProjectRoles ?? [];
    },
    projectMembers() {
      return this.projectRoles?.map((pr) => pr.user);
    },
    roles(): RoleDto[] {
      return this.projectStore.roles ?? [];
    },
    memberHeaders(): TableField<ProjectRoleDto>[] {
      // Define as computed property to have table
      // header text react on language changes.
      return [
        {
          label: this.$t("page.members.givenName"),
          key: "givenName",
          formatter: (_, __, item) => item.user?.givenName ?? "",
          sortByFormatted: true,
          sortable: true,
        },
        {
          label: this.$t("page.members.familyName"),
          key: "familyName",
          formatter: (_, __, item) => item.user?.familyName ?? "",
          sortByFormatted: true,
          sortable: true,
        },
        {
          label: this.$t("page.members.email"),
          key: "email",
          formatter: (_, __, item) => item.user?.email ?? "",
          sortByFormatted: true,
          sortable: true,
        },
        {
          label: this.$t("page.members.role"),
          key: "role",
          formatter: (_, __, item) => item.role?.displayName ?? "",
          sortByFormatted: true,
          sortable: true,
        },
        {
          label: this.$t("page.members.actions"),
          key: "memberActions",
          sortable: false,
        },
      ];
    },
    invitationHeaders(): TableField<ProjectInvitationDto>[] {
      // Define as computed property to have table
      // header text react on language changes.
      return [
        {
          label: this.$t("page.members.email"),
          key: "userMail",
          formatter: (_, __, item) => item.email ?? "",
          sortByFormatted: true,
          sortable: true,
        },
        {
          label: this.$t("page.members.role"),
          key: "roleId",
          formatter: (_, __, item) => item.role?.id ?? "",
          sortByFormatted: true,
          sortable: true,
        },
        {
          label: this.$t("page.members.status"),
          key: "expiration",
          formatter: (_, __, item) => item.expirationDate ?? "",
          sortByFormatted: true,
          sortable: true,
        },
        {
          label: this.$t("page.members.actions"),
          key: "invitationActions",
          sortable: false,
        },
      ];
    },
    isOwner(): boolean | undefined {
      return this.projectStore.currentUserRoleIsOwner;
    },
  },

  methods: {
    // For external users
    async storeNewInvitation(
      projectId: string,
      value: ProjectInvitationForProjectManipulationDto,
      toastText: string,
      errorText: string,
    ) {
      try {
        await this.projectStore.storeInvitation(projectId, value);
        await this.projectStore.retrieveInvitations(this.project);
        this.notificationStore.postNotification({
          title: this.$t("page.members.userManagement").toString(),
          body: toastText,
        });
      } catch {
        this.notificationStore.postNotification({
          title: this.$t("page.members.userManagement").toString(),
          body: errorText,
          variant: "danger",
        });
      }
    },

    resendInvitation(selectedInvitation: ProjectInvitationDto) {
      const invitation: ProjectInvitationForProjectManipulationDto = {
        roleId: selectedInvitation.role?.id ?? "",
        email: selectedInvitation.email ?? "",
      };
      const errorText = this.$t("page.members.invitedUserError", {
        email: selectedInvitation.email,
      }).toString();
      const text = this.$t("page.members.invitedUserText", {
        email: selectedInvitation.email,
        role: selectedInvitation.role?.id
          ? this.getRoleNameFromId(selectedInvitation.role.id)
          : "",
        projectName: this.projectName,
      }).toString();
      this.storeNewInvitation(
        this.project?.id ?? "",
        invitation,
        text,
        errorText,
      );
    },

    revokeInvitation(selectedInvitation: ProjectInvitationDto) {
      // Clone the object to avoid changing the original object
      this.selectedInvitation = structuredClone(toRaw(selectedInvitation));
      this.isDeleteInvitedUserModalVisible = true;
    },

    async confirmRevokeInvitation() {
      if (this.selectedInvitation.id) {
        const text = this.$t("page.members.removedUser", {
          email: this.selectedInvitation.email,
          project: this.projectName,
        }).toString();
        const worked = await this.projectStore.deleteInvitation(
          this.selectedInvitation,
        );
        if (worked) {
          await this.projectStore.retrieveInvitations(this.project);
          this.notificationStore.postNotification({
            title: this.$t("page.members.userManagement").toString(),
            body: text,
          });
        } else {
          const errorMsg = this.$t("page.members.deleteExternalUserError", {
            email: this.selectedInvitation.email,
          }).toString();
          this.notificationStore.postNotification({
            title: this.$t("page.members.userManagement").toString(),
            body: errorMsg,
            variant: "danger",
          });
        }

        this.isDeleteInvitedUserModalVisible = false;
      }
    },

    closeInvitedUserModal() {
      this.isDeleteInvitedUserModalVisible = false;
    },

    async getProjectRoles() {
      this.isBusy = true;
      await this.projectStore.retrieveProjectRoles(this.project);
      this.isBusy = false;
    },

    async setRole(projectRole: ProjectRoleDto) {
      if (this.project && this.project.id && projectRole.id) {
        projectRole.project = { id: this.project.id };

        if (projectRole.role) {
          projectRole.role.displayName =
            projectRole.role.displayName === this.roleStrings.member
              ? this.roleStrings.owner
              : this.roleStrings.member;
        }

        const text = this.$t("page.members.changedRole", {
          project: this.projectName,
          role:
            projectRole.role && projectRole.role.id
              ? this.getRoleNameFromId(projectRole.role.id)
              : "",
          user:
            projectRole.user && projectRole.user.displayName
              ? projectRole.user.displayName
              : "",
        }).toString();

        await this.projectStore.updateMembershipOfProject(
          this.project.id,
          projectRole.id,
          {
            roleId: projectRole.role?.id,
          } as ProjectRoleForProjectManipulationDto,
        );
        await this.getProjectRoles();
        this.notificationStore.postNotification({
          title: this.$t("page.members.userManagement").toString(),
          body: text,
        });
      }
    },

    getRoleNameFromId(roleId: string): string | null | undefined {
      if (this.roles) {
        for (const role of this.roles) {
          if (role.id === roleId) {
            return role.displayName;
          }
        }
      } else {
        return null;
      }
    },

    async addUser(projectRole: ProjectRoleDto, callback?: () => void) {
      if (this.project && this.project.id) {
        projectRole.project = { id: this.project.id };

        const text = this.$t("page.members.addedUser", {
          project: this.projectName,
          role:
            projectRole.role && projectRole.role.id
              ? this.getRoleNameFromId(projectRole.role.id)
              : "",
          user:
            projectRole.user && projectRole.user.displayName
              ? projectRole.user.displayName
              : "",
        }).toString();

        await this.projectStore.addMembershipToProject(this.project.id, {
          roleId: projectRole.role?.id,
          userId: projectRole.user?.id,
        } as ProjectRoleForProjectCreationDto);
        await this.getProjectRoles();
        this.notificationStore.postNotification({
          title: this.$t("page.members.userManagement").toString(),
          body: text,
        });
        if (callback) {
          callback();
        }
      }
    },

    prepareInvitation(projectRole: ProjectRoleDto) {
      this.candidateForInvitation = {
        projectId: this.project?.id ?? "",
        roleId: projectRole.role?.id ?? "",
        email: projectRole.user?.email ?? "",
        expired: false,
        invited: false,
      };
      if (this.invitations) {
        for (const invitation of this.invitations) {
          if (
            invitation.email?.toLowerCase() ===
              projectRole.user?.displayName?.toLowerCase() &&
            invitation.expirationDate
          ) {
            this.candidateForInvitation.invited = true;
            const today = new Date();
            const expirationDate = new Date(invitation.expirationDate);
            if (expirationDate <= today) {
              this.candidateForInvitation.expired = true;
            }
            break;
          }
        }
      }
      if (
        this.candidateForInvitation.invited &&
        !this.candidateForInvitation.expired
      ) {
        this.invitationPendingModal.show();
      } else {
        this.inviteUserModal.show();
      }
    },

    prepareDeletion(projectRole: ProjectRoleDto) {
      this.candidateForDeletion = projectRole;
      this.isDeleteUserModalVisible = true;
    },

    async deleteUser() {
      const text = this.$t("page.members.removedUser", {
        email: this.candidateForDeletion.user?.displayName,
        project: this.projectName,
      }).toString();
      await this.projectStore.deleteProjectRole(this.candidateForDeletion);
      await this.getProjectRoles();
      this.notificationStore.postNotification({
        title: this.$t("page.members.userManagement").toString(),
        body: text,
      });
      this.isDeleteUserModalVisible = false;
    },

    closeUserModal() {
      this.isDeleteUserModalVisible = false;
    },

    onFiltered(filteredItems: ProjectRoleDto[]) {
      this.filteredRows = filteredItems.length;
    },

    onFilteredRows(value: number) {
      this.filteredRows = value;
    },

    setFilter(filter: string) {
      this.filter = filter;
    },
  },
});
</script>
